const _ = require('lodash');
const Joi = require('lx-pjoi');
const evalModel = require('./evalModel');
const getModelDefinition = require('./getModelDefinition');


function makeRemove({ model, key, keyType, keys}) {
  key = key || 'id';
  keyType = keyType || 'number';
  keys = keys || { [key]: keyType };

  const removeModel = function *(args) {
    args = args || {};
    model = evalModel(model);
    const validated = yield Joi.validate(args, removeModel.schema);
    const count = yield model.destroy({
      where: {
        $or: Object.keys(validated).map(aKey => (
          { [aKey]: validated[aKey] }
        )),
      }
    });
    return {
      result: count,
    };
  };

  const joiValidations = {};
  for (const aKey in keys) {
    if ({}.hasOwnProperty.call(keys, aKey)) {
      joiValidations[aKey] = Joi[keys[aKey]]();
    }
  }
  removeModel.schema = Joi.object().keys(joiValidations);
  return removeModel;
}

module.exports = makeRemove;

