const { ValidationErrorException } = require('lx-errors');
const Joi = require('lx-pjoi');
const { client } = require('lx-models');


function *createCategory(args) {
  const Category = client.getModels().Category;
  const input = args;
  // const input = yield Joi.validate(args, createCategory.schema);
  if (yield Category.findOne({ where: { parentId: input.parentId, title: input.title }, raw: true })) {
    throw new ValidationErrorException('Category with the same title under the same hierarchy exists.');
  }
  const result = yield Category.create(input);
  return {
    result: result.toJSON(),
  }
}

// createCategory.schema = Joi.object().keys({
//   sourceId: Joi.string().trim().max(255, 'utf8').allow(null),
//   sourceName: Joi.string().trim().max(255, 'utf8').lowercase().allow(null),
//   isSuspended: Joi.boolean().allow(null),
//   parentId: Joi.number().allow(null).default(null),
//   title: Joi.string().min(2).max(255).required(),
//   description: Joi.string().allow(null),
//   bannerImageUrl: Joi.string().uri().allow(null),
//   priority: Joi.number().allow(null),
// }).with('sourceId', 'sourceName');

module.exports = createCategory;

