const Joi = require('lx-pjoi');
const { client } = require('lx-models');


function *getMetrics() {
  const { Item } = client.getModels();
  const statSince = new Date((new Date()).valueOf() - (1000 * 60 * 60 * 24 * 30));
  return {
    result: {
      totalMarketInUsd: yield Item.scope(null).sum('price_in_usd'),
      totalListings: yield Item.count(),
      newListings: yield Item.count({ where: { createdAt: { $gt: statSince } } }),
    },
  };
}

module.exports = getMetrics;

