const _ = require('lodash');
const { NotAuthorizedException } = require('lx-errors');
const { client } = require('lx-models');
const session = require('../session');


function *getMyDashboard(args) {
  const user = session.get('user');
  if (!user) {
    throw new NotAuthorizedException();
  }
  const { Item } = client.getModels();
  const statuses = ['PENDING', 'APPROVED', 'REJECTED', 'SOLD', 'EXPIRED'];
  const counts = yield statuses.map(status => (
    Item.count({
      where: {
        userId: user.id,
        status: status,
        isSuspended: false,
      }
    })
  ));
  return  {
    result: {
      metrics: _.zipObject(statuses, counts),
    }
  }
};

module.exports = getMyDashboard;

