const jwt = require('jsonwebtoken');
const Joi = require('lx-pjoi');
const makeGet = require('../crud/makeGet');
const defaultGetUser = makeGet({ model: 'User', keys: { id: 'number', username: 'string', email: 'string'} });
const config = require('../../config');


function *getUser(args) {
  const { sessionSecretKey } = config;
  const { sessionToken } = args;
  if (!args.id && sessionToken) {
    const { id } = jwt.verify(sessionToken, sessionSecretKey);
    return yield defaultGetUser({ id });
  }
  return yield defaultGetUser(args);
};

module.exports = getUser;

