const Joi = require('lx-pjoi');
const { client } = require('lx-models');
const makeList = require('../crud/makeList');
const defaultListCategories = makeList({ model: 'Category', queryDefaultLimit: null });


function *listCategories(args) {
  const { nested } = args;
  if (nested) {
    const { Category } = client.getModels();
    const result  = yield Category.findAll({
      where: {
        isSuspended: false,
        parentId: null,
      },
      include: [
        {
          model: Category,
          as: 'children',
          where: { isSuspended: false },
          required: false,
          include: [
            {
              model: Category,
              as: 'children',
              where: { isSuspended: false },
              required: false,
            }
          ]
        }
      ],
      order: [
        ['priority', 'DESC'],
      ],
    });
    return {
      result,
    }
  }
  return yield defaultListCategories(args);
}

module.exports = listCategories;

