const { NotAuthorizedException } = require('lx-errors');
const { client } = require('lx-models');
const session = require('../session');


module.exports = function *({ id }) {
  const { Item } = client.getModels();
  const user = session.get('user');
  if (!user) {
    throw new NotAuthorizedException();
  }
  const item = yield Item.findOne({
    where: {
      id,
      userId: user.id,
    },
  });
  if (!item) {
    throw new NotAuthorizedException();
  }
  const count = yield item.destroy();
  return {
    result: count,
  };
};

