const { ValidationErrorException } = require('lx-errors');
const Joi = require('lx-pjoi');
const { client } = require('lx-models');


function *updateCategory(args) {
  const Category = client.getModels().Category;
  const input = args;
  // const input = yield Joi.validate(args, updateCategory.schema);
  const category = yield Category.findOne({ where: { id: input.id } });

  if (!category) {
    throw NotFoundException();
  }

  const parentId = input.parentId || category.parentId;
  if (yield Category.findOne({ where: { id: { $ne: category.id }, parentId, title: input.title }, raw: true })) {
    throw new ValidationErrorException('Category with the same title under the same hierarchy exists.');
  }
  const result = yield category.update(input);
  return {
    result: result.toJSON(),
  };
}

// updateCategory.schema = Joi.object().keys({
//   id: Joi.number().required(),
//   sourceId: Joi.string().trim().max(255, 'utf8').allow(null),
//   sourceName: Joi.string().trim().max(255, 'utf8').lowercase().allow(null),
//   isSuspended: Joi.boolean().allow(null),
//   parentId: Joi.number().allow(null),
//   title: Joi.string().min(2).max(255),
//   description: Joi.string().allow(null),
//   bannerImageUrl: Joi.string().uri().allow(null),
//   priority: Joi.number().allow(null),
// }).with('sourceId', 'sourceName');

module.exports = updateCategory;

