const { NotAuthorizedException } = require('lx-errors');
const session = require('../session');
const updateItem = require('./updateItem');


function *updateMyItem(args) {
  const user = session.get('user');
  if (!user) {
    throw new NotAuthorizedException();
  }

  // not allowed to update these values
  if (args.status === 'APPROVED' || args.status === 'REJECTED' || args.status === 'PENDING') {
    delete args.status;
  }
  if (args.hasOwnProperty('userId')) {
    delete args.userId;
  }

  return yield updateItem(args);
};

module.exports = updateMyItem;

