const { client } = require('lx-models');
const handlers = require('./handlers');
const auth = require('./auth');
const provideSession = require('./session/provideSession');
const _config = require('../config');


for (const key of Object.keys(handlers)) {
  handlers[key] = provideSession(auth(handlers[key]));
}

function init(config) {
  Object.assign(_config, config);
  client.connect({ dbUrl: config.dbUrl });
}

function close() {
  client.close();
}

module.exports = {
  init,
  close,
  handlers,
};

