const session = require('./index');


module.exports = function(handler) {
  return function *(args) {
    const context = session.createContext();
    session.enter(context);
    let result;
    try {
      result = yield handler(args);
    } finally {
      session.exit(context);
    }
    return result;
  };
};

